SHEBANG
# Copyright @BABOLO (C)2002,2003
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the distribution.
#
# THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
# ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
# IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
# ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
# FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
# DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
# OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
# HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
# LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
# OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
# SUCH DAMAGE.
#
# $Id: up.m4,v 1.1 2003/05/03 04:09:43 babolo Exp $

JNTROSTUP(ijb,,dnl
,dnl
# jailup ijb dir jailname jailaddr uid gid
#     where dir relative to ${JAILUPDIR} and ${JAILRODIR}
# ijb from ports/www/junkbuster useddnl
)

jdir="${1}"
jailsname="${2}"
jailsaddr="${3}"
juid="${4:-0}"
jgid="${5:-0}"
main_dir="${JAILUPDIR}/${jdir}"
conf_dir="${JAILRODIR}/${jdir}"

${mkdir} "${main_dir}" "${conf_dir}"
${up_mdir} "${main_dir}" ${MTREE}
ETCOPY(host.conf hosts resolv.conf)
${up_shlib} "${main_dir}/usr/lib" << "EOF"
    c z gnuregex
EOF

${up_libexe} "${main_dir}/usr/libexec" << EOF
    ld-elf.so.1
    junkbuster
EOF

      #####################################
      ####                             ####
      #### Begin of conf fill          ####
      ####                             ####
cf=configfile; if  [ -e "${conf_dir}/${cf}" ]; then cf="${cf}.sample"; fi
${cat} << "EOF" > "${conf_dir}/${cf}"
#auto-compress
aclfile		/etc/aclfile
#forwardfile	/etc/forwardfile
blockfile	/etc/blockfile
#cookiefile	/etc/cookiefile
#trustfile	/etc/trustfile
#jarfile	/var/log/jarfile
logfile		/var/log/ijb
#add-forwarded-header
#suppress-vanilla-wafer
#wafer		WARNING=Please do not attempt to track me.
#add-header	Accept-Charset: KOI8-R, ISO-8859-1; q=0.1
#listen-address	localhost:8000
#user-agent	.
#referer	@
#from		some@host
#single-threaded

#debug		1	# GPC  = show each GET/POST/CONNECT request
#debug		2	# CONN = show each connection status
#debug		4	# IO   = show I/O status
#debug		8	# HDR  = show header parsing
#debug		16	# LOG  = log all data into the logfile
#debug		15	# same as setting the first 4 listed above

#tinygif	0	# Show a "broken icon"
#tinygif	1	# Show a GIF of one transparent pixel
#tinygif	2	# Show a GIF with the word "JUNKBUSTER"
EOF

cf=aclfile; if  [ -e "${conf_dir}/${cf}" ]; then cf="${cf}.sample"; fi
${cat} << "EOF" > "${conf_dir}/${cf}"
deny	0.0.0.0/0	0.0.0.0/0
permit	0.0.0.0/0	0.0.0.0/0
EOF

cf=blockfile; if  [ -e "${conf_dir}/${cf}" ]; then cf="${cf}.sample"; fi
${cat} << "EOF" > "${conf_dir}/${cf}"
:23
EOF

cf=cookiefile; if  [ -e "${conf_dir}/${cf}" ]; then cf="${cf}.sample"; fi
${cat} << "EOF" > "${conf_dir}/${cf}"
>*
EOF

cf=forwardfile; if  [ -e "${conf_dir}/${cf}" ]; then cf="${cf}.sample"; fi
${cat} << "EOF" > "${conf_dir}/${cf}"
#URL	forw[:port]	gw_type	gw_domain[:port]
#*	.		.	.	# implicit
EOF

cf=trustfile; if  [ -e "${conf_dir}/${cf}" ]; then cf="${cf}.sample"; fi
${cat} << "EOF" > "${conf_dir}/${cf}"
*
EOF
      ####                             ####
      #### End of conf fill            ####
      ####                             ####
      #####################################

${mtree} -Ueqxp "${main_dir}" -f ${MTREE}
${mtree} -Ueqxp "${conf_dir}" << "EOF"
/set type=file uname=root gname=wheel mode=0644 flags=none
.		type=dir mode=0755
    configfile
    aclfile
    blockfile
    cookiefile
    forwardfile
    trustfile
    host.conf
    hosts
    resolv.conf
    localtime
..
EOF

${cat} << EOF >> "${genconfig}"
#${genclass}	${inclass}	${jdir}	${jailsname}	${jailsaddr}	0	${juid}	${jgid}
EOF

      #####################################
      ####                             ####
      #### Begin of fstab mod          ####
      ####                             ####
${cat} << EOF >> "${etcdir}/fstab"
#${conf_dir}		${main_dir}/etc		null	ro,nodev,noexec	0 0
EOF
      ####                             ####
      #### End of fstab mod            ####
      ####                             ####
      #####################################
